#!/usr/bin/python2.7

from twisted.internet import reactor
from txosc import async, dispatch, osc


class gameManagement(object):
    def __init__(self):
        # Create management Dictionnary with all datas from all players
        # and data for management
        # manage is a dict
        #                   address                           message 6 values
        #                     ip,      socket     master, number, score,batx,baty,ballx,bally,frame
        ##self.manage ={  ('10.0.0.10' ,  45789):    [0,      5,      0,  -9.4, 0.0, 0.0,  0.0,   1],
                        ##('10.0.0.9'  ,   36987):    [0,      6,     10,  -9.4, 0.0, 0.0, 0.0,      1],
                        ##('10.0.0.45' ,  12345):     [0,      2,     5,  5.4,  85, -1.3, 0.0,     52],
                        ##('10.0.0.125', 78945):      [0,      8,     0,  7.4,  1.2, 5.2, -1.4,   456]
                        ##} ## self.manage is not empty to test
        self.manage = {}
        ##self.manage = {('10.0.0.5', 78945):[0,8,0,7.4,1.2,5.2,-1.4,4562]}
        # no master, no player
        self.master = ()
        self.numbers = []

    #('10.0.0.10' ,  45789): [ 0,  5,     10,  -9.4, 0.0, 0.0,  0.0,   1]

    def insert_data_in_dict(self, message, address):
        mst, who = 0, 11
        # get master and number
        if self.manage:# no empty
            for key, value in self.manage.items():
                if value[0] == 1:
                    mst = 0
                if value[0] == 0:
                    mst = 1
        else: # manage empty
            mst = 1

        # get player number
        self.numbers = []
        if self.manage:# no empty
            for key, value in self.manage.items():
                self.numbers.append(value[1])
        self.numbers.sort()
        try:
            who = self.numbers[-1] + 1
        except:
            who = 1

        # Get master and number in dict
        if address in self.manage:
            master_number = [self.manage[address][0], self.manage[address][1]]
        else:
            master_number = [mst, who]
        data = master_number
        data.extend(message)

        # Fill the table
        self.manage[address] = data

    def create_msg_for_all_players(self):
        self.msg = osc.Message("/for_all_players")
        for key, value in self.manage.items():
            self.msg.add(key[0])
            value = value[:7]
            for item in value:
                self.msg.add(item)
        #print self.msg
        return self.msg


if __name__ == "__main__":
    # set instance of class
    game = gameManagement()

    test = [ [('10.0.0.9', 47582), [10, -9.4, 0.0, 0.0, 0.0, 1]],
            [('10.0.0.78', 41258), [5, 5.4, 85, -1.3, 0.0, 52]],
            [('10.0.0.111', 65874), [0, 7.4, 1.2, 5.2, -1.4, 456]]  ]

    for t in test:
        game.insert_data_in_dict(t[1], t[0])
        game.create_msg_for_all_players()

#{('10.0.0.4', 39871): [1, 1, 10, -9.447389602661133, -0.0056021548807621, 4.41779088973999, -7.066774368286133, 508]}
#/for_all_players ,ssTiiffffi s:player1  s:10.0.0.4  T:1  i:1  i:10  f:-9.44738960266  f:-0.00560215488076  f:4.41779088974  f:-7.06677436829  i:508
#/who_are_you ,Ti T:1  i:39871
