#!/usr/bin/python2.7

try:
    from twisted.internet import reactor
    from txosc import async, dispatch, osc
except:
    print "You must install python-txosc and maybe python-twisted"

# TODO check if python-twisted is dependency of txosc

from time import time

# local file
import database

host_multicast = "224.0.0.11"
port_multicast = 18888

# set instance of database
gameDB = database.gameDataBase()

toto = False

def player_data_handler(message, address):
    '''
    This function is called every received message from every player.
    So all data are collected here.
    The frequency of this function is the frequency of blender * players number
    With 4 players: 60 * 4 = 240 Hz
    The frequency of dispatched messages must be 60 Hz because Blender
    received at 60 Hz.
    '''
    # insert data
    global toto
    if not toto:
        toto = True
        gameDB.insert_data_in_database(message.getValues(), address)
    gameDB.update_data_in_database(message.getValues(), address)

class UDPMulticastSender(object):
    def __init__(self, port, host=host_multicast):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)
        print("Sending multicast on: %s : %s" % (self.host, self.port))

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))

class UDPMulticastReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenMulticast(self.port,
            async.MulticastDatagramServerProtocol(self.receiver, host_multicast),
            listenMultiple=True)
        print("Listening multicast on: %s : %s" % (host_multicast, self.port))
        # handler for all usefull data from a player
        self.receiver.addCallback("/player_data", player_data_handler)
        '''# quit
        self.receiver.addCallback("/quit", self.quit_handler)

    def quit_handler(self, message, address):
        print("Quit : Got %s from %s" % (message, address))
        reactor.stop()
        print("Goodbye.")'''

if __name__ == "__main__":
    # Set instance
    multicast_sender = UDPMulticastSender(port_multicast)
    multicast_reicever = UDPMulticastReceiver(port_multicast)
    reactor.run()



