#!/usr/bin/python2.7

    def manage_master_number(self, message, address):
        mst, who = False, 11
        # get master and number
        if self.manage:# no empty
            for key, value in self.manage.items():
                if value[0] == True:
                    self.master = key
                    mst = False
                if value[0] == False:
                    self.master = key
                    mst = False
        else:
            self.master = address
            mst = True

        # get player number
        self.numbers = []
        if self.manage:# no empty
            for key, value in self.manage.items():
                self.numbers.append(value[1])
        self.numbers.sort()
        try:
            who = self.numbers[-1] + 1
        except:
            who = 1

        # Get master and number in dict
        if address in self.manage:
            master_number = [self.manage[address][0], self.manage[address][1]]
        else:
            master_number = [mst, who]
        print mst, who
        return [mst, who]

try:
    from twisted.internet import reactor
    from txosc import async, dispatch, osc
except:
    print "You must install python-txosc and maybe python-twisted"

# TODO check if python-twisted is dependency of txosc

from time import time

host_multicast = "224.0.0.11"
port_multicast = 18888

master = False
datas_dict = { ('10.0.0.4', 55525) : (1, [10, -9.4, -0.0, 0.0, 0.0, 456]) }
t0 = int(time())
t1 = time()
compteur = 0
who_play = { 1: 924 }

def players_management(address):
    # master is always player number one
    # master must exist on server and blender
    player_num = 1
    p_list = []
    if not address in datas_dict:
        for key, value in datas_dict.items():
            p_list.append(value[0])
        p_list = sorted(p_list)
        #print p_list
        if p_list:
            if p_list[0] == 1:
                player_num = len(p_list) + 1
            else:
                player_num = 1
    else:
        player_num = datas_dict[address][0]
    who_play[player_num] = 0
    return player_num

def player_data_handler(message, address):
    '''
    This function is called every received message from every player.
    So all data are collected here.
    The frequency of this function is the frequency of blender * players number
    With 4 players: 60 * 4 = 240 Hz
    The frequency of dispatched messages must be 60 Hz because Blender
    received at 60 Hz.
    '''

    # message.getValues()=[10, -9.4, -0.0, 0.0, 0.0] address=('10.0.0.4', 55525)
    # datas_dict = { ('10.0.0.4', 55525) : (1, [10, -9.4, -0.0, 0.0, 0.0]) }
    # create message for all players
    msg = create_fun_msg(datas_dict)
    # fired message
    multicast_sender.send_message(msg)

    # master or slave
    num = players_management(address)
    global master
    if num == 1 and not master:
        master = True
        multicast_sender.send_message(osc.Message("/master", 1))
        print("Message fired : master = 1 ")

    # add data to dict
    datas_dict[address] = (num, message.getValues())

    # test
    who_is_connected()

    ### every second send: player number, master or slave, watch who is connected
    global t0, t1, compteur
    if int(time()) - t0 > 1:
        t0 = time()
        print("Server who = %s datas = %s" % (who_play, datas_dict))
        print
        set_player_number()
        if num != 1:
            multicast_sender.send_message(osc.Message("/master", 0))
            print("Message fired : master = 0 ")
    compteur += 1
    if time() - t1 > 1:
        t1 = time()
        print compteur
        compteur = 0


def set_player_number():
        # send every second correspondence between ip and player number
        who_are_you = [1, 254]
        who = osc.Message("/who_are_you")
        for key, value in datas_dict.items():
            who.add(value[0])
            who.add(key[0])
        multicast_sender.send_message(who)

# who_play = list of tuple (player_number, last_frame)
# who_play = { 1: 924, 3: 254, 2: 564, 5: 45 }

def who_is_connected():
    global who_play
    for key, value in datas_dict.items():
        last_frame = value[1][5]
        player_num = value[0]
        previous_frame = who_play[player_num]
        if last_frame - previous_frame == 0:
            # player_num is disconnected
            del who_play[player_num]
            del datas_dict[key]
            print("disconnected", player_num)

#                       ip       adress   player_number   score   bat_0 x   bat_0 y    ball x   ball y    frame
# datas_dict = {    ('10.0.0.4', 55525) :   (1,          [ 10,    -9.4,     -0.0,       0.0,     0.0,     524]) ,
#                   ('10.0.0.4', 12345) :   (2,          [ 10,    -9.4,     -0.0,       0.0,     0.0,     854]) }
# frame is used to known if player is connected

def create_fun_msg(datas_dict):
    msg = osc.Message("/for_all_players")
    for value in datas_dict.values():
        msg.add("player"+str(value[0]))
        msg.add(value[0])
        for item in value[1]:
            msg.add(item)
    return msg

class UDPMulticastSender(object):
    def __init__(self, port, host=host_multicast):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)
        print("Sending multicast on: %s : %s" % (self.host, self.port))

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))

class UDPMulticastReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenMulticast(self.port,
            async.MulticastDatagramServerProtocol(self.receiver, host_multicast),
            listenMultiple=True)
        print("Listening multicast on: %s : %s" % (host_multicast, self.port))
        # handler for all usefull data from a player
        self.receiver.addCallback("/player_data", player_data_handler)
        # quit
        ##self.receiver.addCallback("/quit", self.quit_handler)

    ##def quit_handler(self, message, address):
        ##print("Quit : Got %s from %s" % (message, address))
        ##reactor.stop()
        ##print("Goodbye.")

if __name__ == "__main__":
    # Set instance
    multicast_sender = UDPMulticastSender(port_multicast)
    multicast_reicever = UDPMulticastReceiver(port_multicast)
    reactor.run()



