'''
# Copyright (C) Labomedia April 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################
'''

import GameLogic as gl
import socket
import OSC3.OSC as OSC
import threading
from time import sleep

global connex_init
global port_received
port_received = False

# ---------------------Open OSC simple server ----------------#
# Handle to receive port
def set_port(addr, tags, stuff, source):
    global port_received
    port_received = True
    gl.port = stuff[0]
    print("Port from server = ", stuff[0])
    if gl.port == 18888:
        gl.master = True
        print("gl.master", gl.master)
    else:
        # disable rigid body
        print("Rigid Body disable")
    svr.close()
    connex_init.close()

# Set server
svr = OSC.ThreadingOSCServer((gl.ip, 18888))
svr.addMsgHandler("/port", set_port)
# Run server
serv_thread = threading.Thread(target=svr.serve_forever)
serv_thread.start()

# --------------------- send player number ------------------#
# OSC basic client+
addr_out = gl.ip, gl.port_out
connex_init = OSC.OSCClient()
# Create a message
m1 = OSC.OSCMessage("/player")
m1.append(gl.ID)

while not port_received :
    try:
        connex_init.sendto(m1, addr_out)
        print("Player Number sended to server:", gl.ID)
        sleep(1)
    except:
        print("Osc Init not send")
        pass

