#!/usr/bin/env python
"""
Example of a multicast UDP txosc receiver with Twisted.

You can run many of these on a single host.

This example is in the public domain.
"""
from twisted.internet import reactor
from txosc import osc
from txosc import dispatch
from txosc import async
from time import sleep
import async_multicast_sender
import threading

global do_loop
do_loop = False
global thd

class MulticastUDPReceiverApplication(object):
    """
    Example that receives multicast UDP OSC messages.
    """
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenMulticast(self.port,
            async.MulticastDatagramServerProtocol(self.receiver, "224.0.0.1"),
            listenMultiple=True)
        print("Listening on osc.udp://224.0.0.1:%s" % (self.port))
        self.receiver.addCallback("/time", self.time_handler)
        self.receiver.addCallback("/egg", self.egg_handler)
        self.receiver.addCallback("/quit", self.quit_handler)
        self.receiver.addCallback("/player", self.player_handler)
        self.receiver.addCallback("/p123/2_bat_0/y", self.bat_handler_y)
        self.receiver.addCallback("/ball", self.ball_handler)

    def time_handler(self, message, address):
        print("time_handler")
        print("  Got %s from %s" % (message, address))

    def egg_handler(self, message, address):
            print("egg_handler")
            print("  Got %s from %s" % (message, address))

    def player_handler(self, message, address):
            print("player")
            print("  Got %s from %s" % (message, address))
            #async_multicast_sender.UDPSenderApplication(18888)

    def bat_handler_y(self, message, address):
            #print("bat")
            print("  Got %s from %s" % (message, address))

    def ball_handler(self, message, address):
            #print("bat")
            print("  Got %s from %s" % (message, address))

    def quit_handler(self, message, address):
            print("quit_handler")
            global do_loop
            do_loop = True
            print("  Got %s from %s" % (message, address))

def bidon(test):
    global do_loop
    while not do_loop:
        print("do loop")
        sleep(0.018)
        s = async_multicast_sender.UDPSenderApplication(18888)

if __name__ == "__main__":
    r = MulticastUDPReceiverApplication(18888)
    #s = async_multicast_sender.UDPSenderApplication(18888)
    ##test = 1
    ##thd = threading.Thread(target=bidon, args=(test, ))
    ##thd.start()
    reactor.run()

##if q = quit:
    ##do_loop = True
    ##thd.join()

