#!/usr/bin/python2.7

from twisted.internet import reactor
from txosc import async, dispatch, osc
import sys
import threading
import time

host_multicast = "224.0.0.11"
port_multicast = 18888
host_local = "127.0.0.1"
port_out = 8000

def foo_handler(message, address):
    udp_sender.send_message(message)
    multicast_sender.send_message(message)

def master_handler(message):
    print("master")
    udp_sender.send_message(message)

class UDPSender(object):
    def __init__(self, port, host=host_local):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))

class UDPMulticastReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenMulticast(self.port,
            async.MulticastDatagramServerProtocol(self.receiver, host_multicast),
            listenMultiple=True)
        print("Listening osc multicast://%s:%s" % (self.port, host_multicast))
        self.receiver.addCallback("/master", master_handler)

if __name__ == "__main__":
    # Set instance
    udp_sender = UDPSender(port_out)
    multicast_reicever = UDPMulticastReceiver(port_multicast)
    reactor.run()



