#!/usr/bin/python2.7

from twisted.internet import reactor
from txosc import async, dispatch, osc
import sys
import threading
import time

host_multicast = "224.0.0.11"
port_multicast = 18888
host_local = "127.0.0.1"
port_in = 9000

def foo_handler(message, address):
    multicast_sender.send_message(message)

class UDPReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenUDP(self.port,
                                async.DatagramServerProtocol(self.receiver))
        print("Listening on osc.udp://localhost:%s" % (self.port))

        # define msg
        self.receiver.addCallback("/ball2", foo_handler)
        self.receiver.addCallback("/2_bat_0", foo_handler)
        #self.receiver.addCallback("/2_bat_1/score", foo_handler)

##Got /ball2/xy ,ff f:-5.71233081818  f:3.5220272541  from ('127.0.0.1', 41824)
##Got /2_bat_1/score ,i i:10  from ('127.0.0.1', 41824)
##Got /2_bat_0 ,iff i:10  f:-9.49839019775  f:-0.00560215488076  from ('127.0.0.1', 41824)


        # quit
        self.receiver.addCallback("/quit", self.quit_handler)

    def quit_handler(self, message, address):
        print("Quit : Got %s from %s" % (message, address))
        reactor.stop()
        print("Goodbye.")

class UDPMulticastSender(object):
    def __init__(self, port, host=host_multicast):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))
        print("Sent with UDPMulticastSender %s to %s:%d" % (message, self.host, self.port))

if __name__ == "__main__":
    # Set instance
    udp_receiver = UDPReceiver(port_in)
    multicast_sender = UDPMulticastSender(port_multicast)
    reactor.run()



